#include "hardware.h"

void initPeripherals(void){
	
	/* Procedura inicjalizujaca glowne peryferia sprzetowe MCU */
	
	/* Wlaczenie taktowania GPIO i szyny APB1 */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_BMX1 |
													RCC_APB1Periph_GPIOA |
													RCC_APB1Periph_GPIOB |
													RCC_APB1Periph_GPIOC |
													RCC_APB1Periph_GPIOD, ENABLE);
	
	/* Konfiguracja linii GPIO do obslugi diod LED - wyjscia niepodciagane do VCC/GND, niska predkosc */
  GPIO_Init(LED1_port, LED1_pin, GPIO_MODE_OUT | GPIO_OTYPE_PP | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	GPIO_Init(LED2_port, LED2_pin, GPIO_MODE_OUT | GPIO_OTYPE_PP | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	
}

void LED_onoff(uint8_t led, LED_state_t state){
	
	/* Wrapper do obslugi diod LED */
	/* led - numer diody (1 lub 2) */
	/* state - nowy stan diody (LED_ON lub LED_OFF) */
	
	if(led == 1){
		
			if(state == LED_ON)
					GPIO_ResetBits(LED1_port, LED1_pin);
			else
					GPIO_SetBits(LED1_port, LED1_pin);
		
	}else if(led == 2){

			if(state == LED_ON)
					GPIO_ResetBits(LED2_port, LED2_pin);
			else
					GPIO_SetBits(LED2_port, LED2_pin);
		
	}
}

void delay(uint32_t ms){
	
	/* Prosta funkcja zatrzymujaca procesor na okolo 1 ms */
	
	for(uint32_t i = 0; i < 3600; i++){
			for(uint32_t j = 0; j < ms; j++) __NOP();
	}
					
}