/* Includes ------------------------------------------------------------------*/
#include "mg32f10x.h"
#include "hardware.h"


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
	
	int16_t cnt = 0;
	int16_t number = 0;
	uint8_t pos = 0;
	
	initPeripherals();
	
	LED_onoff(1, LED_OFF);
	LED_onoff(2, LED_OFF);
	
  while (1)
  {
		/* odczyt stanu przycisku SW1 (1 = niewcisniety, 0 = wcisniety) */
		/* Nacisniecie SW1 zatrzymuje odliczanie */
		if(GPIO_ReadInputDataBit(SW1_port, SW1_pin))
			cnt++;
		
		if(cnt > 100){
			
			cnt = 0;
			
			/* Nacisniecie SW2 przyspiesza odliczanie */
			if(GPIO_ReadInputDataBit(SW2_port, SW2_pin))
				number++;
			else
				number += 10;
			
			/* Obsluga przepelnienia licznika */
			if(number > 9999) number = 0;
						
		}
			
		int8_t digits[4];

		/* Pozyskanie kolejnych pozycji dziesietnych */
		digits[0] = (number % 10000) / 1000;
		digits[1] = (number % 1000) / 100;
		digits[2] = (number % 100) / 10;
		digits[3] = (number % 10);

		/* Tymczasowe wylaczenie wyswietlacza */
		display_select_pos(255);
		
		/* Ustawienie cyfry do wyswietlenia na katodach */
		display_select_digit(digits[pos]);
		
		/* Wlaczenie wybranej pozycji */
		display_select_pos(pos);

		/* Obsluga licznika pozycji dziesietnych */
		pos++;
		if(pos > 3) pos = 0;
			
			delay(1);

		}

}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif
