#include "hardware.h"

void initPeripherals(void){
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_BMX1 |
													RCC_APB1Periph_GPIOA |
													RCC_APB1Periph_GPIOB |
													RCC_APB1Periph_GPIOC |
													RCC_APB1Periph_GPIOD, ENABLE);
	
  GPIO_Init(LED1_port, LED1_pin, GPIO_MODE_OUT | GPIO_OTYPE_PP | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	GPIO_Init(LED2_port, LED2_pin, GPIO_MODE_OUT | GPIO_OTYPE_PP | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	
	GPIO_Init(DISP_A_port, DISP_A_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_B_port, DISP_B_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_C_port, DISP_C_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_D_port, DISP_D_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_E_port, DISP_E_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_F_port, DISP_F_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_G_port, DISP_G_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_DP_port, DISP_DP_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	
	GPIO_Init(DISP_COM1_port, DISP_COM1_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_COM2_port, DISP_COM2_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_COM3_port, DISP_COM3_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_COM4_port, DISP_COM4_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);

	GPIO_Init(SW1_port, SW1_pin, GPIO_MODE_IN | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	GPIO_Init(SW2_port, SW2_pin, GPIO_MODE_IN | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);

}

void LED_onoff(uint8_t led, LED_state_t state){
	
	if(led == 1){
		
			if(state == LED_ON)
					GPIO_ResetBits(LED1_port, LED1_pin);
			else
					GPIO_SetBits(LED1_port, LED1_pin);
		
	}else if(led == 2){

			if(state == LED_ON)
					GPIO_ResetBits(LED2_port, LED2_pin);
			else
					GPIO_SetBits(LED2_port, LED2_pin);
		
	}
}

void delay(uint32_t ms){
	
	for(uint32_t i = 0; i < 3600; i++){
			for(uint32_t j = 0; j < ms; j++) __NOP();
	}
					
}


void display_select_pos(uint8_t pos){
	
	/* obsluga pozycji dziesietnych wyswietlacza (wspolne anody) */
	
	switch(pos){
		
		case 0:
			GPIO_ResetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
			break;
		
		case 1:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_ResetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
			break;		
		
		case 2:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_ResetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
			break;	
		
		case 3:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_ResetBits(DISP_COM4_port, DISP_COM4_pin);
			break;	
	
		default:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
		
	}
}

void display_select_digit(uint8_t dig){
	
	/* obsluga segmentow wyswietlacza (katody) */
	
	switch(dig){
		
		case 0:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;
		
		case 1:
			GPIO_ResetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 2:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_ResetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;	

		case 3:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;	

		case 4:
			GPIO_ResetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 5:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_ResetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;		
	
		case 6:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_ResetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 7:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 8:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;
		
		case 9:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;		
		
		default:
			GPIO_ResetBits(DISP_A_port, DISP_A_pin);
			GPIO_ResetBits(DISP_B_port, DISP_B_pin);
			GPIO_ResetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);

	}	
		
}